
import CardapioInteligente from './src/Services/CardapioInteligente.js';
import IntegracaoCardapio from './src/Services/IntegracaoCardapio.js';
import Optimizer from './src/Services/Optimizer.js';
import Algoritmo from './src/Services/Algoritmo.js';
import ExceptionHandler from './src/Exceptions/ExceptionHandler.js';
import oracledb from 'oracledb';
import NovoCodigo from './src/Providers/NovoCodigo.js';
import BD from './src/connection.js';
import moment from 'moment';
import axios from 'axios';
import JWT from './src/Libraries/JWT.js';
import fs from 'fs';

async function test(){
  try {
    const paramsGetData = {
      "P_CDFILIAL": "0001",
      "P_CDSERVFILI": "00001",
      "P_DTREFCUSPADR": "01/11/2021",
      "P_IDTIPORESTRICAO": "PLANEJADO",
      "P_DTMESCARD": "01/11/2021",
      "P_NRTIPOCUSTO": "01",
      "P_DTREFECUSTO": "20/12/2021",
      "P_DTMES": "01/11/2021",
      "P_DIAS_CONG": "0",
      "P_DIA_SEMANA": "1",
      "P_CDNVPRATO": "4",
      "P_IDUTRPADCA": "S",
      "currentUserCode": "012345678910",
      "$token": "eyJ0eXAiOiJKV1QiLCJleHAiOjE2NDA2ODEwNjF9.eyJDRE9QRVJBRE9SIjoiMDEyMzQ1Njc4OTEwIiwiTlJPUkciOiIxMTAyIiwiR1JBTlRfQUxMIjp0cnVlLCJTQ09QRVMiOltdfQ,,.wMOhGwQkdugDp4CG-2qQoqT5kV_XBodk7j1qJhC6gcU,"
    };//req.body;
        const dataSet = await CardapioInteligente.retDadosCardInteligente(paramsGetData);
        const resultGetGenData = dataSet.data;
        // console.log(dataSet);
        CardapioInteligente.addIncidencia_tp_gp_prato(dataSet);
        
        dataSet.CDOPERADOR = "012345678910";
        dataSet.P_DTMES = "01/11/2021";
        dataSet.P_VRCUSTPADR = "5";
        dataSet.VLR_CUSTO_MAX = "9.95";
        dataSet.VLR_CUSTO_MIN = "4.95";
        const params = {
            url : "http://10.250.1.2:4000/",
            body: dataSet
        };
        console.log('Finish genData...');
        const optimized = await Algoritmo.call(params);
        console.log('Finish call Algoritmo...');
        if(optimized && optimized.data){
            console.log(`Cardápio otimizado com sucesso.
            Buraco: ${optimized.data.data.comBuraco}
            Custo Total: ${optimized.data.data}`);
        }
        const paramCenario = optimized.data.data;
        paramCenario.JSONCENARIO = JSON.stringify(paramCenario);
        if(!paramCenario.pu_aculm){
          paramCenario.pu_aculm = "";
        }
        paramCenario.JSONCARDAPIO = '{}';
        paramCenario.incidencia = dataSet.incidencia;
        paramCenario.freqData = Optimizer.feedFreqData(
          paramCenario
        );
        paramCenario.INGData = Optimizer.feedINGData(
          paramCenario
        );
        // paramCenario.backOfficeData = JSON.parse('{"CDPICTPRAT":"99.99.99.999","CDPICTPROD":"9.99.99.999.99","DSDNSCARDOTIMIZADO":null,"IDUTRPADCA":"S","CDFILIAL":"0001","NMFILIAL":"0001 - TEKNISA SERVICOS DE ALIMENTAÇÃO 2","CDSERVFILI":"00001","NMSERVICO":"00001 - ALMOCO","TPCONTRATO":"PLANEJADO","NMCONTRATO":"Planejado","DTMESCARD":"01/11/2021","VLR_CONGELADO":0,"DTREFECUSTO":"27/12/2021","costTypeOptions":[{"CDTIPOCUSTO":"01","NMTIPOCUSTO":"Custo Médio Líquido Atual"},{"CDTIPOCUSTO":"02","NMTIPOCUSTO":"Custo Médio Bruto Atual"},{"CDTIPOCUSTO":"03","NMTIPOCUSTO":"Custo Médio Líquido da Época"},{"CDTIPOCUSTO":"04","NMTIPOCUSTO":"Custo Médio Bruto da Época"},{"CDTIPOCUSTO":"06","NMTIPOCUSTO":"Custo de Cotação (Lista de Preços)"},{"CDTIPOCUSTO":"07","NMTIPOCUSTO":"Custo da Última compra(AF)"},{"CDTIPOCUSTO":"08","NMTIPOCUSTO":"Custo de Compra Liquido da Época"}],"costType":{"CDTIPOCUSTO":"01","NMTIPOCUSTO":"Custo Médio Líquido Atual"},"groupProdLimitOptions":[{"CDGRUPPROD":"0000000001","NMGRUPPROD":"RESULTADO OPERACIONAL"},{"CDGRUPPROD":"0000000003","NMGRUPPROD":"ALIMENTARES OTIMIZADOR"},{"CDGRUPPROD":"0000000004","NMGRUPPROD":"TRANSPORTADA"},{"CDGRUPPROD":"2","NMGRUPPROD":"GRUPO CRIADO PARA TESTE"}],"groupProdLimit":{"CDGRUPPROD":"0000000001","NMGRUPPROD":"RESULTADO OPERACIONAL"},"linkCommonDishes":0,"CDGRUPPRODOTMCARD":null,"VRCUSTPADR":"5","PERC_CUSTO_MAX":"99","PERC_CUSTO_MIN":"1","VLR_CUSTO_MIN":"4.95","VLR_CUSTO_MAX":"9.95","MIN_VLR_CONGELADO":0,"MAX_VLR_CONGELADO":30,"P_DIA_SEMANA":1,"NRTIPOCUSTO":"01","parsedCardapio":"\\"\\"","NRCENARIOVINCULO":null}');
        Object.assign(paramCenario, paramsGetData);
        CardapioInteligente.insereCenario(paramCenario);
        // CardapioInteligente.insereCenario(cardData);
       // res.json(paramCenario);
    } catch ( error ) {
        ExceptionHandler.defaultHandler( error );
        //res.send({error: error.message});
    }
};
async function test2(){
  const result = await CardapioInteligente.execProc('TESTE_PROCEDURE', {
    PARAM_TESTE: {
      dir: oracledb.BIND_IN, 
      val: 'ABCDEFIOKL', 
      type: oracledb.STRING
    },
    PARAM_OUT: {
      dir: oracledb.BIND_OUT,
      type: oracledb.STRING,
      maxSize: 20
    }
  });
  console.log(result);
};
async function test3(){
    const result = await NovoCodigo.getCodeByTableName('OTIMIZADOR_TESTE', 1102);
    console.log(result);
};
async function testInsert(parameters){
    const result = await BD.execSQL(`
      INSERT INTO TESTE_INSERT (NUMERO, DESCRIPTION, DTINCLUSAO, TEXTO) VALUES (:NUMERO, :DESCRIPTION, :DTINCLUSAO, :TEXTO) 
    `, parameters || {
      NUMERO: {
        dir: oracledb.BIND_IN,
        val: 99,
        type: oracledb.NUMBER
      },
      DESCRIPTION: {
        dir: oracledb.BIND_IN,
        val: "teste",
        type: oracledb.STRING
      },
      DTINCLUSAO: {
        dir: oracledb.BIND_IN,
        val: "01/03/2021"
      },
      TEXTO: {
        dir: oracledb.BIND_IN,
        val: `{"teste":23}`.padEnd(100000000, 'a')
      }
    });
    console.log(result);
}

async function test5(){
  const paramObj = {
    NRCENARIOCARD: '0000000660',
    DTCENARIOCARD: '28/12/2021',
    CDFILIAL     : '0001',
    CDSERVFILI   : '00001',

    DTMESCARD   : '01/11/2021',
    CDOPERADOR  : '012345678910',
    JSONCENARIO : '{}',
    JSONCARDAPIO: '{}',

    VRCUSTPADR : '5',
    VRPUCENARIO: 4.098517044466665,
    NRORG      : '1102',
    IDATIVO    : 'S',

    DTULTATU      : null,
    NRORGINCLUSAO : '1102',
    CDOPERINCLUSAO: '012345678910',

    NRORGULTATU    : null,
    CDOPERULTATU   : null,
    IDTIPORESTRICAO: 'PLANEJADO',
    QTCOMENSAIS    : 50,

    DTREFECUSTMES        : '20/12/2021',
    CDTIPOCUSTO          : '01',
    NRCENARIOCARDORIGINAL: null,
    NRCENARIOVINCULO     : null,
  };
  const response = await BD.execSQL(`
                INSERT INTO CENARIOCARD
                    (
                        NRCENARIOCARD, DTCENARIOCARD, CDFILIAL,                 CDSERVFILI,
                        DTMESCARD,     CDOPERADOR,    JSONCENARIO,              JSONCARDAPIO,
                        VRCUSTPADR,    VRPUCENARIO,   NRORG,                    IDATIVO,
                        DTINCLUSAO,    DTULTATU,      NRORGINCLUSAO,            CDOPERINCLUSAO,
                        NRORGULTATU,   CDOPERULTATU,  IDTIPORESTRICAO,          QTCOMENSAIS,
                        DTREFECUSTMES, CDTIPOCUSTO,   NRCENARIOCARDORIGINAL,    NRCENARIOVINCULO
                    )
                VALUES (
                        :NRCENARIOCARD, :DTCENARIOCARD, :CDFILIAL,              :CDSERVFILI,
                        :DTMESCARD,     :CDOPERADOR,    :JSONCENARIO,           :JSONCARDAPIO,
                        :VRCUSTPADR,    :VRPUCENARIO,   :NRORG,                 :IDATIVO,
                        SYSDATE,        :DTULTATU,      :NRORGINCLUSAO,         :CDOPERINCLUSAO,
                        :NRORGULTATU,   :CDOPERULTATU,  :IDTIPORESTRICAO,       :QTCOMENSAIS,
                        :DTREFECUSTMES, :CDTIPOCUSTO,   :NRCENARIOCARDORIGINAL, :NRCENARIOVINCULO
                )
                `,
                Object.assign(
                    BD.createParam('NRCENARIOCARD',  paramObj.NRCENARIOCARD),
                    BD.createParam('DTCENARIOCARD',  paramObj.DTCENARIOCARD),
                    BD.createParam('CDFILIAL',       paramObj.CDFILIAL),
                    BD.createParam('CDSERVFILI',     paramObj.CDSERVFILI),

                    BD.createParam('DTMESCARD',      paramObj.DTMESCARD),
                    BD.createParam('CDOPERADOR',     paramObj.CDOPERADOR),
                    BD.createParam('JSONCENARIO',    paramObj.JSONCENARIO),
                    BD.createParam('JSONCARDAPIO',   paramObj.JSONCARDAPIO),

                    BD.createParam('VRCUSTPADR',     paramObj.VRCUSTPADR || 0),
                    BD.createParam('VRPUCENARIO',    paramObj.VRPUCENARIO || 0),
                    BD.createParam('NRORG',          paramObj.NRORG),
                    BD.createParam('IDATIVO',        'S'),

                    BD.createParam('DTULTATU',       null),
                    BD.createParam('NRORGINCLUSAO',  paramObj.NRORG),
                    BD.createParam('CDOPERINCLUSAO', paramObj.CDOPERADOR),

                    BD.createParam('NRORGULTATU',     null),
                    BD.createParam('CDOPERULTATU',    null),
                    BD.createParam('IDTIPORESTRICAO', paramObj.IDTIPORESTRICAO),
                    BD.createParam('QTCOMENSAIS',     paramObj.QTCOMENSAIS),

                    BD.createParam('DTREFECUSTMES',         paramObj.DTREFECUSTMES),
                    BD.createParam('CDTIPOCUSTO',           paramObj.CDTIPOCUSTO),
                    BD.createParam('NRCENARIOCARDORIGINAL', paramObj.NRCENARIOCARDORIGINAL || null),
                    BD.createParam('NRCENARIOVINCULO',      paramObj.NRCENARIOVINCULOD || null)
                ));
};
async function test6(){
  console.log(await NovoCodigo.getCodeByTableName('CENARIOCARD', 1102));
};
async function test7(){
    const result = await axios({
          method: 'POST',
          url: "http://10.250.1.162:4000",
          headers: {'Content-Type': 'application/json'},
          data: {}
      }).catch( error => {
          console.log('error');
          console.log(error.response.data.otmmessage);
          // console.log(error.response.data);
      });
        console.log('Finis2h');
        console.log(result);
};
function testJWT(token){
  console.log(JWT.getTokenData(token));
};
async function testGetParametrosCusto(){
    const result = await CardapioInteligente.getParametrosCustoItGeracaoCard('202');
    console.log(result);
}
async function testLog(){
    const params = {
  "P_CDFILIAL": "0001",
  "P_CDSERVFILI": "00001",
  "P_DTREFCUSPADR": "01/11/2021",
  "P_IDTIPORESTRICAO": "PLANEJADO",
  "P_DTMESCARD": "01/11/2021",
  "P_NRTIPOCUSTO": "01",
  "P_DTREFECUSTO": "20/12/2021",
  "P_DTMES": "01/11/2021",
  "P_DIAS_CONG": "0",
  "P_DIA_SEMANA": "1",
  "P_CDNVPRATO": "4",
  "P_IDUTRPADCA": "S",
	"P_NRITGERACAOCARD": "202",
	"currentUserCode": "012345678910",
	"$token": "eyJ0eXAiOiJKV1QiLCJleHAiOjE2NDA2ODEwNjF9.eyJDRE9QRVJBRE9SIjoiMDEyMzQ1Njc4OTEwIiwiTlJPUkciOiIxMTAyIiwiR1JBTlRfQUxMIjp0cnVlLCJTQ09QRVMiOltdfQ,,.wMOhGwQkdugDp4CG-2qQoqT5kV_XBodk7j1qJhC6gcU,"
};
    const tokenData = JWT.getTokenData(params.$token);
    params.NRORG = tokenData.NRORG;
    params.CDOPERADOR = tokenData.CDOPERADOR;
    const result = await CardapioInteligente.insereLog(params);
    return result;
}
// testWrite(){
//     fs.writeFileSync('/home/gabriel');
// }
async function test10(){
  const result = await BD.execQuery(`SELECT JSONCENARIO FROM CENARIOCARD WHERE NRCENARIOCARD = 683`,{});
  // console.log(result);
  // Optimizer.feedFreqData(JSON.parse(result[0].JSONCENARIO))['0000000002'];
  console.log((Object.values(Optimizer.feedFreqData(JSON.parse(result[0].JSONCENARIO))['0000000002'].GRUPOS).filter(e=>e.freqError)[0].NMEXIB));
  // console.log(Optimizer.feedFreqData(JSON.parse(result[0].JSONCENARIO))['0000000002'].GRUPOS);
  // console.log(Optimizer.feedFreqData(JSON.parse(result[0].JSONCENARIO))['0000000002'].NMAGRUPGRPRAT);
  // console.log(Optimizer.feedFreqData(JSON.parse(result[0].JSONCENARIO))['0000000002'].distribution_of_incidences);
  // console.log(Optimizer.feedFreqData(JSON.parse(result[0].JSONCENARIO)));
  // fs.writeFileSync('./pedrao.json', JSON.stringify(result));
}

async function testBackOfficeData(){
    let result = await CardapioInteligente.getBackOfficeData('6', '202');
    console.log(result);
}

async function testPublish(NRCENARIOCARD){
    let reqParams = {
       NRCENARIOCARD,
       "$token": "eyJ0eXAiOiJKV1QiLCJleHAiOjE2NDEyMjgyNzZ9.eyJDRE9QRVJBRE9SIjoiMDEyMzQ1Njc4OTEwIiwiTlJPUkciOiIxMTAyIiwiR1JBTlRfQUxMIjp0cnVlLCJTQ09QRVMiOltdfQ,,.rq5NFgJKwiBwX1IUjmUKfFuCldvun7yQwrdys-gAbDQ,"
    };
    const { CDOPERADOR, NRORG } = JWT.getTokenData(reqParams.$token);
    Object.assign(reqParams, { CDOPERADOR, NRORG });
    delete reqParams.$token;
    IntegracaoCardapio.integracaoCardapio(reqParams);
}
const defaultRes = {
  send(param){
    console.log(param);
  }, 
  json(param){
    console.log(param);
  }
}
async function testOptimizer(req, res = defaultRes){
  try {
        const requestParams = req.body;
        const { NRGERACAOCARD, NRITGERACAOCARD, $token } = requestParams;
        const { CDOPERADOR, NRORG } = JWT.getTokenData($token);
        const backOfficeData = await CardapioInteligente.getBackOfficeData(NRGERACAOCARD, NRITGERACAOCARD);
        let paramsGetGenData = {
            IDTIPORESTRICAO: backOfficeData.TPCONTRATO,
            DTREFCUSPADR   : backOfficeData.DTMESCARD,
            DTMES          : backOfficeData.DTMESCARD,
            DIAS_CONG      : backOfficeData.QTDIASCONG,
            CDNVPRATO      : backOfficeData.CDPICTPRAT.match(/\./g).length+1,
            CDOPERADOR,
            NRORG
        };
        const params = Object.assign({}, requestParams, paramsGetGenData, backOfficeData);
        const dataSet = await CardapioInteligente.retDadosCardInteligente( params );
        CardapioInteligente.addIncidencia_tp_gp_prato(dataSet);
        const { VRCUSTPADR, VLR_CUSTO_MAX, VLR_CUSTO_MIN } = backOfficeData;
        Object.assign(dataSet, {
            VRCUSTPADR, VLR_CUSTO_MAX, VLR_CUSTO_MIN, 
            CDOPERADOR, NRORG, 
            P_DTMES: backOfficeData.DTMESCARD,
            P_VRCUSTPADR: VRCUSTPADR
        });
        const token = requestParams.$token;
        Object.assign(requestParams, {CDOPERADOR, NRORG});
        const paramsAlgoritmo = {
            url : process.env.HOST_ALGORITMO_SERVER,
            body: dataSet
        };
        console.log('Finish genData...');
        let error = null;
        console.log(dataSet);
        // console.log(paramsAlgoritmo);
        const optimized = await Algoritmo.call(paramsAlgoritmo).catch( err => {
            console.log(err.response);
            if(err.response && err.response.data){
                error = err.response.data;
            } else {
                error = {
                    success: false,
                    otmmessage: "Erro inesperado",
                    title: "UNEXPECTED_ERROR"
                }
            }
        });
        let response = null;
        let promises = [];
        if(error){
            error.IDTIPOLOG = error.title;
            error.DSLOGINTERNO = error.otmmessage;
            response = {
                status: 'failed',
                data: error
            };
            let logParameters = Object.assign({}, requestParams, error);
            const result = await CardapioInteligente.insereLog(logParameters);
            res.json(response);
        } else {
            console.log('Finish call Algoritmo...');
            const paramCenario = optimized.data.data;
            paramCenario.backOfficeData = backOfficeData;
            Object.assign(paramCenario, requestParams, params);
            promises.push(Algoritmo.checkGeneration(paramCenario));
            paramCenario.JSONCENARIO = JSON.stringify(paramCenario);
            paramCenario.JSONCARDAPIO = '{}';
            paramCenario.incidencia = dataSet.incidencia;
            paramCenario.pu_aculm = paramCenario.pu_aculm 
                ? parseFloat(paramCenario.pu_aculm).toFixed(5) 
                : "";
            paramCenario.freqData = Optimizer.feedFreqData( paramCenario );
            paramCenario.INGData = Optimizer.feedINGData( paramCenario );
            promises.push(CardapioInteligente.insereCenario(paramCenario));
            Promise.all(promises).then( resp => {
                const [ _, NUMERO_CENARIO ] = resp;
                res.json(NUMERO_CENARIO);
            }).catch( error => {
                res.json({
                    status: 'failed',
                    data: {message: error.message, stack: error.stack}
                });
            });
        }
    } catch ( error ) {
        ExceptionHandler.defaultHandler( error );
        res.send({error: error.message});
    }
}

async function testInsertLogIntCompcard(){
   const SQL = `INSERT INTO LOGINTCOMPCARD (NRLOGINTCOMPCARD, NRLOGINTCARDAMES, NRLOGINTCARDADIA, CDFILAUXPRAT, CDPRATO, NRSEQPRATCAR, CDTIPOPRAT, VRPECONSCARD) VALUES (:NRLOGINTCOMPCARD, :NRLOGINTCARDAMES, :NRLOGINTCARDADIA, :CDFILAUXPRAT, :CDPRATO, :NRSEQPRATCAR, :CDTIPOPRAT, :VRPECONSCARD)`;
   const result = await BD.execSQL(SQL, 
        {
            NRLOGINTCOMPCARD: '0000018122',
            NRLOGINTCARDAMES: '0000000120',
            NRLOGINTCARDADIA: '0000003358',
            CDPRATO: '070301000',
            CDFILAUXPRAT: 'P',
            NRSEQPRATCAR: '5',
            CDTIPOPRAT: '04',
            VRPECONSCARD: 98.44
        }
  ).catch(erro => console.log('erro insert') || console.log(erro));
}
test10();